package com.dbxml.db.common.scripting;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: PythonExtension.java,v 1.2 2004/02/12 00:17:56 bradford Exp $
 */

import java.util.Map;

import com.dbxml.labrador.types.Variant;

import org.python.util.PythonInterpreter;

/**
 * PythonExtension is an experimental Extension for executing Python with
 * the Jython interpreter.
 */

public final class PythonExtension extends ScriptExtension {
   private static final String[] EmptyStrings = new String[0];

   public Variant execute(Map args) {
      PythonInterpreter pi = new PythonInterpreter();

      // Standard Imports
      pi.exec("from com.dbxml.db.core import Database");
      pi.exec("from com.dbxml.db.core import Collection");
      pi.exec("from com.dbxml.db.core import Container");
      pi.exec("from com.dbxml.db.common.scripting import *");
      pi.exec("from org.w3c.dom import *");
      pi.exec("from com.dbxml.xml import *");

      // Standard Variables
      pi.set("this", this);
      pi.set("database", collection.getDatabase());
      pi.set("collection", collection);

      // Arguments
      String[] names = (String[])args.keySet().toArray(EmptyStrings);
      for ( int i = 0; i < names.length; i++ ) {
         Object obj = args.get(names[i]);
         pi.set(names[i], obj);
      }

      // Now run the actual script
      pi.exec(script);

      // Return any possible result
      Object res = pi.get("result");
		if ( res != null )
			return new Variant(res);
		else
			return null;
   }
}

